﻿$(document).ready(function () {
    $("input:radio[name='tbVisibility']").change(function () {
        checkVisibility();
    });

    checkVisibility();

    $("#dialog-new-category").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 600,
        buttons: [
           {
               text: Localization_Ok,
               click: function () {
                   $(this).dialog("close");
               }
           },

        ],
        close: function (event, ui) {
            RealodSelect2ForCategories();
            ReloadTableOfCategories();
        }
    });
    
    $("#dialog-new-reply").on("click", "#slConstant a", function () {

        tinyMCE.activeEditor.dom.add(tinyMCE.activeEditor.getBody(), 'p', {}, $(this).data("value"));
    });

    $('body').on('click', '#aEditCategory', function () {
        OnAjaxBegin();

        $("#dialog-new-category").load(
            RQ_URL + "/PredefinedReply/PartialCategories",
            function () {
                $("#dialog-new-category").dialog('open');
                InitSortableGroupRows();
                OnAjaxComplete();
            }
        );
    });

    $('#dialog-new-category').on('click', '#btAddCategory', function () {
        AddCategory();
    });
});

function DeleteReplyConfirm(id)
{
    $("#dialog-confirm-reply-delete").dialog({
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    DeleteReply(id);
                    $(this).dialog("close");
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialog-confirm-reply-delete").dialog("open");
}

var selectedCategory = -1;

function checkVisibility() {
    var value = $('input[name="tbVisibility"]:checked').val();
    if (value == -1) {
        $("#tbOperators").prop("disabled", true);
    }
    else {
        $("#tbOperators").prop("disabled", false);
    }
}

function RealodSelect2ForCategories() {
    $("#trCategoryOption").empty();
    $("#trCategoryOption").html("<div class='loading-16'></div>");
    $("#trCategoryOption").load(RQ_URL + "/PredefinedReply/PartialCategoriesDialog");
}

function AddCategory(name) {
    $('#spanCategoryRequired').hide();

    var error = false;

    if ($('#tbCategoryName').val().trim() == '') {
        $('#spanCategoryRequired').show();
        error = true;
    }

    if (!error) {
        $('#btAddCategory').addClass("loading-16");

        $.post(
            RQ_URL + "/PredefinedReply/AddCategory",
            $.param(
                {
                    name: $('#tbCategoryName').val(),
                },
                true
            ),
            function (data) {
                if (data.success) {
                    $('#tbCategoryName').val('');
                }
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () { ReloadTableOfCategories(); })
            .done(function () { $('#btAddCategory').removeClass("loading-16"); });
    }
}


function ReloadTableOfCategories() {
    $("#tableBodyOfCategory").load(
        RQ_URL + "/PredefinedReply/PartialTableOfCategories",
        function () {
            InitSortableGroupRows(); //reinit
        }
    );
}

function SaveCategory(id) {
    var tr = $('#tableBodyOfCategory tr[data-category-id="' + id + '"].category-group');

    tr.find('div.editable .spanCategoryRequired').hide();

    var error = false;

    if (tr.find('div.editable input[type="text"].tbCategoryName').val().trim() == '') {
        tr.find('div.editable .spanCategoryRequired').show();
        error = true;
    }

    if (!error) {
        tr.find('.btSaveCategory').addClass("loading-16");

        $.post(
            RQ_URL + "/PredefinedReply/SaveCategory",
            $.param(
                {
                    id: id,
                    name: tr.find('div.editable input[type="text"].tbCategoryName').val(),
                },
                true
            ),
            function (data) {
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () { ReloadTableOfCategories(); })
            .done(function () { tr.find('.btSaveCategory').removeClass("loading-16"); });
    }
}

function DeleteCategoryConfirm(id) {
    $("#dialog-confirm-category-delete").dialog({
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    DeleteCategory(id);
                    $(this).dialog("close");
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialog-confirm-category-delete").dialog("open");
}

function DeleteCategory(id) {
    OnAjaxBegin();

    $.post(
        RQ_URL + "/PredefinedReply/DeleteCategory",
        {
            id: id,
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); })
        .success(function () { ReloadTableOfCategories(); })
        .done(function () { OnAjaxComplete(); });
}

function EditCategory(id) {
    $('#tableBodyOfCategory tr.category-group div.editable').hide();
    $('#tableBodyOfCategory tr.category-group div.readonly').show();

    var tr = $('#tableBodyOfCategory tr[data-category-id="' + id + '"].category-group');

    tr.find('div.editable input[type="text"].tbCategoryName').val(tr.find('div.editable input[type="hidden"].tbCategoryName').val());

    tr.find('div.readonly').hide();
    tr.find('div.editable').show();
}

function CancelEditCategory(id) {
    var tr = $('#tableBodyOfCategory tr[data-category-id="' + id + '"].category-group');
    tr.find('div.editable').hide();
    tr.find('div.readonly').show();
}

function InitSortableGroupRows() {
    $("#tableBodyOfCategory").sortable({
        handle: ".handle",
        update: function (event, ui) {
            var data = $(this).sortable('toArray', { attribute: 'data-category-id' });

            $.post(
                RQ_URL + "/PredefinedReply/SortCategories",
                $.param(
                    { sortedIds: data },
                    true
                ),
                function (data) {
                },
                "json"
                )
                .error(function (error) { alert(error.responseText); })
                .success(function () { })
                .done(function () { });
        }
    });
}

function reloadTableReply() {
    $("#TableReplies").load(
        RQ_URL + "/PredefinedReply/PartialReloadReplies"
    );
}